#include <stdio.h> // Used for printf() statements 
#include <wiringPi.h> // Include WiringPi library! 

// Pin number declarations. We're using the Broadcom chip pin numbers. 
const int PIN_CLK = 18; // CLK - Board pin 12 -- BCM pin 18 
const int PIN_CS = 17; // CLK - Board pin 11 -- BCM pin 17 
const int PIN_DO = 27; // CLK - Board pin 13 -- BCM pin 27 

char conv(char dato,char medclk, char j) 
{ 
	dato = 0; 
	digitalWrite(PIN_CS, LOW); 
	delayMicroseconds(1); 
	digitalWrite(PIN_CLK, HIGH); 
	delayMicroseconds(medclk); 
	digitalWrite(PIN_CLK, LOW); 
	delayMicroseconds(medclk); 
	digitalWrite(PIN_CLK, HIGH); 
	delayMicroseconds(medclk); 
	digitalWrite(PIN_CLK, LOW); 

	for(j = 0; j < 8; j++){
		delayMicroseconds(medclk); 
		dato = dato << 1; 
		if(digitalRead(PIN_DO)) 
			dato = dato | 0x01; 
		digitalWrite(PIN_CLK, HIGH);
		delayMicroseconds(medclk);
		digitalWrite(PIN_CLK, LOW); 
	} 
	delayMicroseconds(medclk); 
	digitalWrite(PIN_CS, HIGH); 
	return dato;
} 

int main(void) 
{ 
	// Setup stuff: 
	wiringPiSetupGpio(); // Initialize wiringPi -- using Broadcom pin numbers 

	//Declarando Pines 
	pinMode(PIN_CLK, OUTPUT); 
	pinMode(PIN_CS, OUTPUT); 
	pinMode(PIN_DO, INPUT); 

	//Poniendo condiciones iniciales 
	digitalWrite(PIN_CLK, LOW); 
	digitalWrite(PIN_CS, HIGH); 

	char dato, j, vect[100], medclk = 1; 
	int i; 

	while(1){ 
		for(i = 0; i < 100; i++){ 
			vect[i] = conv(dato,medclk,j); 
			delayMicroseconds(1); 
		} 
		for(i = 0; i < 1000; i++){ 
			printf("%d ",vect[i]); 
		} 
		printf("\n\n"); 
		delay(500); 
	} 

	return 0; 
}